<?php
namespace Teknisa\CADFIS\Controllers;

use \Teknisa\Libs\Service\CRUD;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class Pais extends \Teknisa\CADFIS\Controllers\TeknisaCrud {

    protected $dataSourceName = "pais";

    public function __construct(CRUD $crudService, ParameterBag $parameterBag, Environment $environment,$ger01300paisservice) {
        parent::__construct($crudService, $parameterBag);
        $this->environment = $environment;
        $this->ger01300paisservice = $ger01300paisservice;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $nrorgLogada = $this->environment->getNrOrgTrab();
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName($this->dataSourceName);
            $filterCriteria->addCondition('NRORG', 'IN', array($nrorgLogada, 0));
            $this->crudService->find($response, $filterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }

      public function save(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $rows = $this->crudService->getRowsToSave($request, $this->dataSourceName);
            $this->ger01300paisservice->savePais($rows[0]);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }


}